CrushChance = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceDB-2.0","AceEvent-2.0")
--local deformat = AceLibrary("Deformat-2.0")

CrushChance:RegisterDB("CrushChanceDB")
--talent defense number
CrushChance:RegisterDefaults("profile", {
	tdn = 20,
	dw=false,
	x=400,
	y=400
} )

--[[
/script DEFAULT_CHAT_FRAME:AddMessage("Need 102.4 combined avoidance. Currently at:",0.8,0.8,1) 
/script DEFAULT_CHAT_FRAME:AddMessage(GetDodgeChance()+GetBlockChance() + GetParryChance() +5+(GetCombatRatingBonus(CR_DEFENSE_SKILL) + 20)*0.04,1,0.5,0) 
]]

function CrushChance:OnInitialize()
    -- Called when the addon is loaded
	--create frame
	local options = { 
		type='group',
		args = {
			tdn = {
				type = 'range',
				name = 'TDN',
				desc = 'Talent Defense Number, type info to see where this number comes into the formula.',
				get = 'GetTdn',
				set = 'SetTdn',
				min = 0,
				max = 100,
				step = 1
			},
			dw = {
				type='toggle',
				name = 'Attacker dual-wields',
				desc = 'Assume the attacker is dual-wielding and subtract 20%',
				get = 'IsDualWielding',
				set = 'SetDualWielding',				
			},
			reset = {
				type = 'execute',
				name = 'Reset Position',
				desc = 'Reset the position of crush chance in case you lost it',
				func = 'ResetPosition'
			},
			info = {
				type = 'execute',
				name = 'Calculation Info',
				desc = 'Prints information on how the calculation is performed.',
				func = 'PrintCalcInfo'
			}							    			
		}}
		
	self:RegisterChatCommand({"/crushchance"}, options)    	
end

function CrushChance:OnEnable()
	if self.frame == nil then
		--create frame
		local f = CreateFrame("Frame",nil,UIParent)
		f:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",
					self.db.profile.x,self.db.profile.y)
		f:SetWidth(60)
		f:SetHeight(20)		
		--local t = f:CreateFontString("GameFontNormal")
		local t = f:CreateFontString(nil,"OVERLAY","GameFontNormal")
		t:SetAllPoints(f)
		f.chanceText = t
		
		f:EnableMouse(true)
		f:SetMovable(true)		
		
		f:SetScript("OnMouseDown",
			function()
				f:StartMoving()
			end)
		f:SetScript("OnMouseUp",
			function()
				f:StopMovingOrSizing()
				CrushChance:SavePosition()
			end)
			
		self.frame = f
	end
	self:UpdateChance("player")
	self.frame:Show()
	
	self:RegisterEvent("UNIT_AURA","UpdateChance")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","UpdateChance")
end

function CrushChance:OnDisable()
    -- Called when the addon is disabled
	--unregister hide
	--self:UnregisterAllBucketEvents()
	self:UnregisterAllEvents()
	self.frame:Hide()
end

function CrushChance:UpdateChance(unitId)
	if unitId~="player" then
		return
	end
	local chance = 102.4 - ( GetDodgeChance()+GetBlockChance() + GetParryChance() +5+(GetCombatRatingBonus(CR_DEFENSE_SKILL) + self.db.profile.tdn)*0.04 )
	if self.db.profile.dw then
		chance = chance-20
	end
	local colorStr
	if chance<=0 then
		chance=0
		--green
		colorStr="|cFF00FF00"
	else
		colorStr="|cFFFF0000"
	end
	
	--SetText(sprintf("%s%d"))
	self.frame.chanceText:SetText( string.format("%s%.1f|r",colorStr, chance) )
end

function CrushChance:SavePosition()
	self.db.profile.x = self.frame:GetLeft()
	self.db.profile.y = self.frame:GetTop()
end	

-- GET/SET
function CrushChance:SetTdn(v)
	self.db.profile.tdn = v
	self:UpdateChance("player")
end

function CrushChance:GetTdn()
	return self.db.profile.tdn
end
function CrushChance:SetDualWielding(v)
	self.db.profile.dw = v
	self:UpdateChance("player")
end
function CrushChance:IsDualWielding()
	return self.db.profile.dw
end
function CrushChance:ResetPosition()
	local f = self.frame
	f:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",
		UIParent:GetWidth()/2, UIParent:GetHeight()/2)	
end
function CrushChance:PrintCalcInfo()
	self:Print("The number you see is calculated with the following formula:\n102.4 - ( GetDodgeChance()+GetBlockChance() + GetParryChance() +5+(GetCombatRatingBonus(CR_DEFENSE_SKILL) + TDN)*0.04 )\n\nThis represents your chance to be hit or crushed, if the number is below 20 any hits you receive will be crushing.")
end

